package main

import (
	"encoding/json"
	"fmt"
	"os"
	"sort"
	"strconv"
	"strings"
	"time"

	log "github.com/sirupsen/logrus"

	"gitlab.com/mergetb/api/facility/v1/go/state"
	portal "gitlab.com/mergetb/api/portal/v1/go"
	xir "gitlab.com/mergetb/xir/v0.3/go"
)

const (
	// the time to wait after issuing qmp/ACPI shutdown request to a VM until the VM
	// emits a SHUTDOWN confirmation
	SOFT_REBOOT_TIMEOUT_SEC int = 30
)

type PCIAddr struct {
	Bus      int
	Device   int
	Function int
}

type PCINicPort struct {
	Capacity uint64
	Vid      uint32 // 0 = newer VXLAN based, >0 is older VLAN based
	Bridge   string // name of mariner bridge
	Address  PCIAddr
	Mac      string
	TapIdx   int
	Queues   uint64
}

type PCINic struct {
	Map   map[uint32]*PCINicPort
	Model string
}

type PCIDisk struct {
	Capacity uint64
	Address  PCIAddr
}

type PCINicTopology struct {
	// HostMap maps a NIC number to the flat port number that it corresponds to
	// in the XIR NicSpec
	SpecMap map[uint32]uint32

	// NICMap maps a NIC number to the VM's virtual PCI NIC
	NicMap map[uint32]*PCINic
}

type PCIDiskTopology struct {
	Map map[uint32]*PCIDisk
}

type PCITopology struct {
	Nics  *PCINicTopology
	Disks *PCIDiskTopology
	Image *PCIAddr
}

type Socket struct {
	NumCores uint32
	Memory   uint64
}

type SocketTopology struct {
	// HostMap maps virtual socket numbers to the physical socket they correspond
	// to (as specified by xir)
	HostMap map[uint32]uint32

	// SocketMap maps virtual socket numbers to the VM's virtual socket allocation
	SocketMap map[uint32]*Socket
}

type VMConfig struct {
	PCITopo    *PCITopology
	SocketTopo *SocketTopology
	OSImage    string
	IsBios     bool
}

func getVMNics(topology *PCINicTopology) ([]int, error) {
	var nics []int

	if topology != nil {
		for _, nic := range topology.NicMap {
			for _, port := range nic.Map {
				if port.TapIdx != -1 {
					nics = append(nics, port.TapIdx)
				}
			}
		}
	}

	return nics, nil
}

func getVMNicsConfig(config *VMConfig) ([]int, error) {
	return getVMNics(config.PCITopo.Nics)
}

func reapVMNics(topology *PCINicTopology) error {
	if topology != nil {
		for _, nic := range topology.NicMap {
			for _, port := range nic.Map {
				if port.TapIdx != -1 {
					name := getTapName(port.TapIdx)
					err := freeTap(name)
					if err != nil {
						return err
					}
					freeTapIdx(port.TapIdx)
					log.Debugf("reaped %s", name)

					if port.Vid == 0 {
						err = removeBridge(port.Bridge)
						if err != nil {
							log.WithFields(log.Fields{"err": err, "bridge": port.Bridge}).Error("remove bridge")
						}
					}
				}
			}
		}
	}

	return nil
}

func reapVMConfig(fqvm string, config *VMConfig) error {
	releaseOSImage(fqvm, config)
	return reapVMNics(config.PCITopo.Nics)
}

func reapVM(fqvm string) error {
	defer cleanupVMHost(fqvm)

	config, err := restoreVMConfig(fqvm)
	if err != nil {
		return err
	}

	err = reapVMConfig(fqvm, config)
	if err != nil {
		return err
	}

	return nil
}

func startVM(fqvm string, qemu_cmd []string) error {
	log.Debugf("qemu-system-x86_64 %s", strings.Join(qemu_cmd, " "))

	err := podmanStartVM(fqvm, qemu_cmd)
	if err != nil {
		return err
	}

	// wait up to 5 seconds for files generated by VM launch to show up
	start := time.Now()
	have_pid := false
	have_qmp := false

	for {
		if have_pid && have_qmp {
			break
		}

		if !have_pid {
			_, err := getVMPid(fqvm)
			if err == nil {
				have_pid = true
			}
		}

		if !have_qmp {
			if _, err := os.Stat(getQmpSockFile(fqvm)); err == nil {
				have_qmp = true
			} else if !os.IsNotExist(err) {
				return err
			}
		}

		if time.Since(start) > 5*time.Second {
			return fmt.Errorf("timed out waiting to see VM pid_file")
		}
	}

	log.Debugf("created container for VM %s", fqvm)

	return nil
}

func killVM(fqvm string) error {
	log.Debugf("stopping container for VM %s", fqvm)
	return podmanStopVM(fqvm)
}

func nextPCIAddr(prev *PCIAddr) (*PCIAddr, error) {
	bus := prev.Bus
	device := prev.Device

	if device == 31 {
		// qemu SHPC based hotplug does not allow devices being placed in slot 0
		device = 1
		if bus == 31 {
			return nil, fmt.Errorf("last bus/slot reached")
		} else {
			bus++
		}
	} else {
		device++
	}

	return &PCIAddr{
		Bus:      bus,
		Device:   device,
		Function: 0,
	}, nil
}

func xirModelToQemuModel(nicSpec *xir.NICSpec, port_idx uint32) string {
	if (nicSpec == nil) || (nicSpec.Ports == nil) || (int(port_idx) >= len(nicSpec.Ports)) {
		return "virtio-net-pci"
	}

	model := nicSpec.Ports[port_idx].Model
	if model == nil {
		return "virtio-net-pci"
	}

	if model.Op != xir.Operator_EQ {
		log.Debugf("NICModelConstraint with non EQ operator?")
	}

	switch model.Value {
	case xir.NICModel_Virtio:
		return "virtio-net-pci"
	case xir.NICModel_E1000:
		return "e1000"
	case xir.NICModel_E1000E:
		return "e1000e"
	default:
		log.Warningf("Mariner does not currently support NIC model %d; using virtio-net-pci", model.Value)
		return "virtio-net-pci"
	}
}

func xirModelToQueues(nicSpec *xir.NICSpec, port_idx uint32) uint64 {
	if (nicSpec == nil) || (nicSpec.Ports == nil) || (int(port_idx) >= len(nicSpec.Ports)) {
		return 1
	}

	queues := nicSpec.Ports[port_idx].Queues
	if queues == nil {
		return 1
	}

	if queues.Op != xir.Operator_EQ {
		log.Debugf("PortSpec:Queues with non EQ operator?")
	}

	return queues.Value
}

func xirNicSpecToPCI(spec *xir.NICsAllocation, topo *PCINicTopology) error {
	// need to iterate the nics in order
	nics := make([]int, 0)
	for nic_id := range spec.Alloc {
		nics = append(nics, int(nic_id))
	}
	sort.Ints(nics)

	port_idx := uint32(0)
	for _, nic_id := range nics {
		nic := spec.Alloc[uint32(nic_id)]
		num_ports := uint32(len(nic.Alloc))

		topo.SpecMap[uint32(nic_id)] = port_idx
		port_idx += num_ports
	}

	return nil
}

func xirNicsToPCI(fqvm string, spec *xir.NICsAllocation, nicSpec *xir.NICSpec, addr *PCIAddr) (*PCINicTopology, error) {
	topology := new(PCINicTopology)
	topology.SpecMap = make(map[uint32]uint32)
	topology.NicMap = make(map[uint32]*PCINic)

	if nicSpec == nil {
		nicSpec = new(xir.NICSpec)
	}

	// prepend the nicSpec with an infranet NIC model, as nicSpec only comes with xpnet
	if nicSpec == nil {
		nicSpec = new(xir.NICSpec)
	}

	nicSpec.Ports = append(
		[]*xir.PortSpec{{
			Capacity: &xir.Uint64Constraint{
				Op:    xir.Operator_EQ,
				Value: xir.Mbps(100),
			},
			Queues: &xir.Uint64Constraint{
				Op:    xir.Operator_EQ,
				Value: 1,
			},
			Model: &xir.NICModelConstraint{
				Op:    xir.Operator_EQ,
				Value: xir.NICModel_Virtio,
			},
		}},
		nicSpec.Ports...,
	)

	// generate flat topology index
	err := xirNicSpecToPCI(spec, topology)
	if err != nil {
		return nil, err
	}

	// we sort the NICs because we want the interfaces to show up in a predictable, repeatable
	// order in the VM. Otherwise, run-to-run and even node-to-node non-determinism will result,
	// and users will be sad
	nkeys := make([]int, 0)
	for nic_id := range spec.Alloc {
		nkeys = append(nkeys, int(nic_id))
	}
	sort.Ints(nkeys)

	for _, k := range nkeys {
		nic_id := uint32(k)
		nic := spec.Alloc[nic_id]

		new_addr, err := nextPCIAddr(addr)
		if err != nil {
			return nil, err
		}
		*addr = *new_addr

		topology.NicMap[nic_id] = new(PCINic)
		topology.NicMap[nic_id].Map = make(map[uint32]*PCINicPort)

		if _, ok := nic.Alloc[0]; !ok {
			return nil, fmt.Errorf("found xir NICAllocation with no port in slot 0")
		}

		// get the index into the NicSpec for this nic
		spec_id := topology.SpecMap[nic_id]
		nic_model := xirModelToQemuModel(nicSpec, spec_id)
		topology.NicMap[nic_id].Model = nic_model

		// iterate the ports in order, for the same reason as the nics above
		pkeys := make([]int, 0)
		for nic_id := range nic.Alloc {
			pkeys = append(pkeys, int(nic_id))
		}
		sort.Ints(pkeys)

		for _, p := range pkeys {
			port_id := uint32(p)
			port := nic.Alloc[port_id]

			port_model := xirModelToQemuModel(nicSpec, spec_id+port_id)
			if nic_model != port_model {
				return nil, fmt.Errorf("cannot emulate NIC with different device models per port")
			}

			if port.Name == "" {
				return nil, fmt.Errorf("cannot emulate NIC without a port name")
			}

			var brname string
			var vid uint32

			br := port.GetBridge() // may be missing for existing realizations
			if br != nil {
				brname = br.Bridge
				vid = br.Vid
			} else {
				// backwards compatible support where the info is in etcd under the Tap key

				// find the waypoint associated with this spec
				vid, err = findPortVid(fqvm, port.Name)
				if err != nil {
					return nil, fmt.Errorf("cannot emulate NIC: cannot find port %s.%s: %v", fqvm, port.Name, err)
				}
				brname = mariner_bridge // single bridge
			}

			log.Debugf("found VID %d on bridge %s for port %s.%s", vid, brname, fqvm, port.Name)

			new_addr.Function = int(port_id)
			topology.NicMap[nic_id].Map[port_id] = &PCINicPort{
				Capacity: port.Capacity,
				Vid:      vid, // 0 = newer VXLAN-based Hypervisor, >0 for older VLAN-based
				Bridge:   brname,
				Address:  *new_addr,
				Mac:      port.Mac,
				TapIdx:   -1,
				Queues:   xirModelToQueues(nicSpec, spec_id+port_id),
			}
		}
	}

	return topology, nil
}

func xirDisksToPCI(spec *xir.DisksAllocation, addr *PCIAddr) (*PCIDiskTopology, error) {
	topology := new(PCIDiskTopology)
	topology.Map = make(map[uint32]*PCIDisk)

	for disk_id, disk := range spec.Alloc {
		new_addr, err := nextPCIAddr(addr)
		if err != nil {
			return nil, err
		}
		*addr = *new_addr

		topology.Map[disk_id] = &PCIDisk{
			Capacity: disk.Capacity,
			Address:  *new_addr,
		}
	}

	return topology, nil
}

// Map an xir ResourceAllocation to a PCI based representation
func xirToPCI(fqvm string, spec *xir.ResourceAllocation) (*PCITopology, error) {
	var err error

	topology := new(PCITopology)
	start := PCIAddr{
		Bus:      1,
		Device:   1,
		Function: 0,
	}

	// nics
	if spec.NICs != nil {
		topology.Nics, err = xirNicsToPCI(fqvm, spec.NICs, spec.Model.NIC, &start)
		if err != nil {
			return nil, err
		}
	}

	// image next
	topology.Image, err = nextPCIAddr(&start)
	if err != nil {
		return nil, err
	}
	start = *topology.Image

	// disks
	if spec.Disks != nil {
		topology.Disks, err = xirDisksToPCI(spec.Disks, &start)
		if err != nil {
			return nil, err
		}
	}

	return topology, nil
}

func xirToSocket(spec *xir.ResourceAllocation) (*SocketTopology, error) {
	topology := new(SocketTopology)
	topology.HostMap = make(map[uint32]uint32)
	topology.SocketMap = make(map[uint32]*Socket)

	// determine total memory size
	total_mem := uint64(0)
	for _, dimm := range spec.Memory.Alloc {
		total_mem += dimm.Capacity
	}

	// we currently just divide memory equally among the virtual sockets
	mem_per_socket := total_mem / uint64(len(spec.Procs.Alloc))

	guest_id := uint32(0)
	for socket_id, socket := range spec.Procs.Alloc {
		topology.HostMap[guest_id] = socket_id
		topology.SocketMap[guest_id] = &Socket{
			NumCores: socket.Cores,
			Memory:   mem_per_socket,
		}
		guest_id++
	}

	return topology, nil
}

func xirToOSImage(spec *xir.ResourceAllocation) string {
	return spec.Model.Image.Value
}

// Translates xir specification to a set of configuration for the Qemu instance
func xirToVMConfig(fqvm string, spec *xir.ResourceAllocation) (*VMConfig, error) {
	var err error

	config := new(VMConfig)

	log.Debugf("received XIR ResourceAllocation: %v", spec)

	// generate PCI topology
	config.PCITopo, err = xirToPCI(fqvm, spec)
	if err != nil {
		return nil, fmt.Errorf("failed to translate xir specification to PCI topology: %v", err)
	}

	// generate a socket topology
	config.SocketTopo, err = xirToSocket(spec)
	if err != nil {
		return nil, fmt.Errorf("failed to translate xir specification to Socket topology: %v", err)
	}

	// save OS image
	config.OSImage = xirToOSImage(spec)

	return config, nil
}

func badAllocation(msg string) error {
	return fmt.Errorf("malformed xir.ResourceAllocation: %s", msg)
}

func sanityCheckSpec(spec *xir.ResourceAllocation) error {
	if spec.Procs == nil {
		log.Debugf("no Procs in ResourceAllocation; defaulting to 1 VCPU on socket 0")
		spec.Procs = &xir.ProcAllocation{
			Alloc: map[uint32]*xir.SocketAllocation{
				0: {
					Cores: 1,
				},
			},
		}
	}

	if spec.Memory == nil {
		log.Debugf("no Memory in ResourceAllocation; defaulting to 1 GB on 0th DIMM")
		spec.Memory = &xir.MemoryAllocation{
			Alloc: map[uint32]*xir.DimmAllocation{
				0: {
					Capacity: uint64(1 << 30),
				},
			},
		}
	}

	if spec.Model == nil {
		return badAllocation("nil Model")
	}

	return nil
}

func qmpAddVirtioNic(fqvm, device_id, netdev_id, mac string, addr *PCIAddr, mq bool, vectors uint64) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	dev := &VirtioNetPci{
		DeviceBase: DeviceBase{
			Driver: "virtio-net-pci",
			Bus:    fmt.Sprintf("pci_bridge1.%d", addr.Bus),
			Id:     device_id,
		},
		Addr:          fmt.Sprintf("0x%x.0x%x", addr.Device, addr.Function),
		Netdev:        netdev_id,
		Mac:           mac,
		Multifunction: true,
		Mq:            mq,
		Vectors:       uint32(vectors),
	}

	_, err = q.CommandEncodeJSON("device_add", dev)
	if err != nil {
		return fmt.Errorf("device_add (model:virtio-net-pci) failed: %v", err)
	}

	return nil
}

func qmpAddE1000Nic(fqvm, device_id, netdev_id, mac string, addr *PCIAddr) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	dev := &E1000{
		DeviceBase: DeviceBase{
			Driver: "e1000",
			Bus:    fmt.Sprintf("pci_bridge1.%d", addr.Bus),
			Id:     device_id,
		},
		Addr:          fmt.Sprintf("0x%x.0x%x", addr.Device, addr.Function),
		Netdev:        netdev_id,
		Mac:           mac,
		Multifunction: true,
	}

	_, err = q.CommandEncodeJSON("device_add", dev)
	if err != nil {
		return fmt.Errorf("device_add (model:e1000) failed: %v", err)
	}

	return nil
}

func qmpAddE1000ENic(fqvm, device_id, netdev_id, mac string, addr *PCIAddr) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	dev := &E1000E{
		DeviceBase: DeviceBase{
			Driver: "e1000e",
			Bus:    fmt.Sprintf("pci_bridge1.%d", addr.Bus),
			Id:     device_id,
		},
		Addr:          fmt.Sprintf("0x%x.0x%x", addr.Device, addr.Function),
		Netdev:        netdev_id,
		Mac:           mac,
		Multifunction: true,
	}

	_, err = q.CommandEncodeJSON("device_add", dev)
	if err != nil {
		return fmt.Errorf("device_add (model:e1000e) failed: %v", err)
	}

	return nil
}

func qmpAddVirtioBlk(fqvm, device_id, drive string, addr *PCIAddr, boot bool) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	dev := &VirtioBlkPci{
		DeviceBase: DeviceBase{
			Driver: "virtio-blk-pci",
			Bus:    fmt.Sprintf("pci_bridge1.%d", addr.Bus),
			Id:     device_id,
		},
		Drive: drive,
		Addr:  fmt.Sprintf("0x%x", addr.Device),
	}

	if boot {
		dev.BootIndex = 0
	}

	_, err = q.CommandEncodeJSON("device_add", dev)
	if err != nil {
		return fmt.Errorf("device_add (model:virtio-blk-pci) failed: %v", err)
	}

	return nil
}

func qmpAddNetdev(fqvm, device_id, bridge string, num_queues uint64) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	dev := &Netdev{
		&NetdevBase{
			Type: "tap",
			Id:   device_id,
		},
		&NetdevTapOptions{
			Ifname:     device_id,
			Script:     "no",
			Downscript: "no",
			Br:         bridge,
			Vhost:      true,
			Vhostforce: true,
			Queues:     uint32(num_queues),
		},
	}

	_, err = q.CommandEncodeJSON("netdev_add", dev)
	if err != nil {
		return fmt.Errorf("netdev_add failed: %v", err)
	}

	return nil
}

func qmpAddQcow2Disk(fqvm string, fname string, nodename string) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	dev := &BlockdevOptions{
		Base: &BlockdevOptionsBase{
			Driver:   Qcow2,
			NodeName: nodename,
		},
		Qcow2: &BlockdevOptionsQcow2{
			BlockdevOptionsGenericCOWFormat: &BlockdevOptionsGenericCOWFormat{
				BlockdevOptionsGenericFormat: &BlockdevOptionsGenericFormat{
					File: &BlockdevRef{
						Indicator: Definition,
						Definition: &BlockdevOptions{
							Base: &BlockdevOptionsBase{
								Driver: File,
							},
							File: &BlockdevOptionsFile{
								Filename: fname,
							},
						},
					},
				},
			},
		},
	}

	_, err = q.CommandEncodeJSON("blockdev-add", dev)
	if err != nil {
		return fmt.Errorf("blockdev-add failed: %v", err)
	}

	return nil
}

func qmpQueryPCI(fqvm string, vm *state.Vm) ([]PciInfo, error) {
	var devs []PciInfo

	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return devs, err
	}
	defer q.Close()

	obj, err := q.Command("query-pci", nil)
	if err != nil {
		return devs, err
	}

	bytes, err := json.Marshal(obj)
	if err != nil {
		return devs, err
	}

	err = json.Unmarshal(bytes, &devs)
	if err != nil {
		return devs, err
	}

	return devs, nil
}

func qmpQueryCpuInfo(fqvm string) ([]CpuInfoFast, error) {
	var cpus []CpuInfoFast

	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return cpus, err
	}
	defer q.Close()

	dat, err := q.Command("query-cpus-fast", nil)
	if err != nil {
		return cpus, fmt.Errorf("query-cpus-fast failed: %v", err)
	}

	bytes, err := json.Marshal(dat)
	if err != nil {
		return cpus, err
	}

	err = json.Unmarshal(bytes, &cpus)
	if err != nil {
		return cpus, err
	}

	return cpus, nil
}

func qmpCheckVMStatus(fqvm string) (StatusInfo, error) {
	var status StatusInfo

	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return status, err
	}
	defer q.Close()

	obj, err := q.Command("query-status", nil)
	if err != nil {
		return status, fmt.Errorf("query-status failed: %v", err)
	}

	bytes, err := json.Marshal(obj)
	if err != nil {
		return status, err
	}

	err = json.Unmarshal(bytes, &status)
	if err != nil {
		return status, err
	}

	return status, nil
}

func qmpStartVM(fqvm string) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	_, err = q.Command("cont", nil)
	if err != nil {
		return fmt.Errorf("cont failed: %v", err)
	}

	return nil
}

func addPortQmp(fqvm string, topology *PCINicTopology, nic_id, port_id uint32) error {
	var err error

	port := topology.NicMap[nic_id].Map[port_id]

	tap_id, err := allocTapIdx(fqvm)
	if err != nil {
		return err
	}

	netdev_id := getTapName(tap_id)
	device_id := fmt.Sprintf("nic%d.%d", nic_id, port_id)

	// only restrict vlan assignment if a specific port VID is requested
	err = allocTap(netdev_id, port.Bridge, port.Vid, port.Queues > 1, port.Vid != 0)
	if err != nil {
		return err
	}

	log.Debugf("alloced %s", netdev_id)

	err = qmpAddNetdev(fqvm, netdev_id, port.Bridge, port.Queues)
	if err != nil {
		return err
	}

	mac := port.Mac
	if mac == "" {
		log.Warnf("no MAC address for port; generating now")

		mac, err = generateUnicastMacAddr()
		if err != nil {
			return err
		}
	}

	model := topology.NicMap[nic_id].Model
	log.Debugf("adding device model:%s", model)

	switch model {
	case "virtio-net-pci":
		// number of MSIX vectors recommended as 2*#queues + 2
		// source: https://www.linux-kvm.org/page/Multiqueue
		vectors := port.Queues*2 + 2
		err = qmpAddVirtioNic(fqvm, device_id, netdev_id, mac, &port.Address, port.Queues > 1, vectors)
	case "e1000":
		err = qmpAddE1000Nic(fqvm, device_id, netdev_id, mac, &port.Address)
	case "e1000e":
		err = qmpAddE1000ENic(fqvm, device_id, netdev_id, mac, &port.Address)
	default:
		return fmt.Errorf("unknown device model %s", model)
	}

	if err != nil {
		return err
	}

	// save mac and tap_id in config
	port.Mac = mac
	port.TapIdx = tap_id

	return nil
}

func addNicsQmp(fqvm string, topology *PCINicTopology) error {
	var err error

	for nic_id, nic := range topology.NicMap {
		for port_id := range nic.Map {
			// The first function on a multifunction device has to be
			// hotplugged last, as Qemu does not allow hotplugging subfunctions
			// to an already existent multi-function device plugged into the
			// first slot
			if port_id == 0 {
				continue
			} else {
				err = addPortQmp(fqvm, topology, nic_id, port_id)
				if err != nil {
					return err
				}
			}
		}

		// add port 0 now
		if _, ok := nic.Map[0]; ok {
			err = addPortQmp(fqvm, topology, nic_id, 0)
			if err != nil {
				return err
			}
		}
	}

	return nil
}

func addDisksQmp(fqvm string, topology *PCIDiskTopology) error {
	for disk_id, disk := range topology.Map {
		fname := getDiskFile(fqvm, "qcow2", disk_id)
		drive := fmt.Sprintf("block%d", disk_id)
		device_id := fmt.Sprintf("disk%d", disk_id)

		// create qcow2 image
		err := createQcow2Image(fname, disk.Capacity)
		if err != nil {
			return err
		}

		// add backend drive to VM
		err = qmpAddQcow2Disk(fqvm, fname, drive)
		if err != nil {
			return err
		}

		err = qmpAddVirtioBlk(fqvm, device_id, drive, &disk.Address, false)
		if err != nil {
			return err
		}
	}

	return nil
}

func addImageQmp(fqvm string, addr *PCIAddr) error {
	fname := getRootfsFile(fqvm)
	drive := "block-boot"
	device_id := "vd-boot"

	err := qmpAddQcow2Disk(fqvm, fname, drive)
	if err != nil {
		return err
	}

	err = qmpAddVirtioBlk(fqvm, device_id, drive, addr, true)
	if err != nil {
		return err
	}

	return nil
}

type AsyncResult struct {
	msg AsyncMessage
	err error
}

func watchAsync(q *QMPSession, ch chan *AsyncResult) {
	msg, err := q.readAsync()
	ch <- &AsyncResult{
		msg: msg,
		err: err,
	}
	close(ch)
}

// This function performs a "hard reset" of the VM
func qmpCycleVM(fqvm string) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	_, err = q.Command("system_reset", nil)
	if err != nil {
		return fmt.Errorf("system_reset failed: %v", err)
	}

	return nil
}

// This function requests the guest to perform a powerdown operation. It may or may not
// respond to the request
func qmpPowerdownVM(fqvm string, timeout int) error {
	sock := getQmpSockFile(fqvm)

	q, err := QMPOpen("unix", sock)
	if err != nil {
		return err
	}
	defer q.Close()

	_, err = q.Command("system_powerdown", nil)
	if err != nil {
		return fmt.Errorf("system_powerdown failed: %v", err)
	}

	if timeout == 0 {
		return nil
	}

	for {
		ch := make(chan *AsyncResult)
		go watchAsync(&q, ch)
		select {
		case result := <-ch:
			if result.err != nil {
				return result.err
			}

			switch result.msg.Event {
			case "SHUTDOWN":
				return nil
			default:
				log.Debugf("received event '%s' from vm '%s'", result.msg.Event, fqvm)
			}
		case <-time.After(time.Duration(timeout) * time.Second):
			return fmt.Errorf("timed out waiting for SHUTDOWN")
		}
	}
}

func configVMQmp(fqvm string, config *VMConfig) error {
	var err error

	if config.PCITopo.Nics != nil {
		err = addNicsQmp(fqvm, config.PCITopo.Nics)
		if err != nil {
			return err
		}
	}

	err = addImageQmp(fqvm, config.PCITopo.Image)
	if err != nil {
		return err
	}

	if config.PCITopo.Disks != nil {
		err = addDisksQmp(fqvm, config.PCITopo.Disks)
		if err != nil {
			return err
		}
	}

	return nil
}

func buildQemuPCIBridges(bus_idx int, num_devs int) ([]string, error) {
	num_bridges := num_devs / 31
	if num_devs%31 != 0 {
		num_bridges++
	}

	bus := fmt.Sprintf("pcie_pci_bridge%d", bus_idx)

	var cmd_list []string
	for slot := 1; slot <= num_bridges; slot++ {
		// xxx how to set chassis_nr?
		cmd_list = append(cmd_list,
			"-device",
			fmt.Sprintf("pci-bridge,id=pci_bridge%d.%d,bus=%s,chassis_nr=1,addr=0x%x", bus_idx, slot, bus, slot),
		)
	}

	return cmd_list, nil
}

func getNumVirtioNICs(topo *PCITopology) int {
	num_nics := 0

	if topo != nil && topo.Nics != nil {
		for _, nic := range topo.Nics.NicMap {
			num_nics += len(nic.Map)
		}
	}

	return num_nics
}

func getNumVirtioDisks(topo *PCITopology) int {
	// 1 for boot image
	num_disks := 1

	if topo != nil && topo.Disks != nil {
		num_disks += len(topo.Disks.Map)
	}

	return num_disks
}

func buildQemuPCIeTopology(config *VMConfig) ([]string, error) {
	var cmd_list []string

	topo := config.PCITopo

	// 31 usable slots in each bridge, 31 bridges attached to the top-level pcie-pci-bridge
	// we could expand this via additional pcie-pci-bridges
	num_usable_slots := 31 * 31

	num_nics := getNumVirtioNICs(topo)
	num_disks := getNumVirtioDisks(topo)
	num_devs := num_nics + num_disks

	if num_devs > num_usable_slots {
		return nil, fmt.Errorf(
			"mariner supports at most %d PCI devices, but %d (%d NICs, %d disks) requested", num_usable_slots, num_devs, num_nics, num_disks)
	}

	// Allocate a PCIe-PCI bridge
	cmd_list = append(cmd_list, "-device", "pcie-pci-bridge,id=pcie_pci_bridge1,bus=pcie.0")

	// Allocate a number of PCI-PCI bridges based on how many devices are needed
	bridges, err := buildQemuPCIBridges(1, num_devs)
	if err != nil {
		return nil, err
	}

	cmd_list = append(cmd_list, bridges...)

	return cmd_list, nil
}

/*
 * The realization service resource allocation algorithms are not currently
 * doing any sort of NUMA aware allocations. It's possible, for example, that
 * some memory will come from multiple NUMA socket, while CPUs may all come from a
 * single socket.
 *
 * Given this, it does not make much sense to expose NUMA topologies to the VM. Just create
 * a single virtual socket that houses all of the memory and cpus. If realization becomes
 * more NUMA aware, we can rethink whether it makes sense to expose underlying allocations
 * to the guest
 */
/*
func buildQemuNUMATopology(config *VMConfig) ([]string, error) {
	var cmd_list []string

	topo := config.SocketTopo
	num_sockets := len(topo.SocketMap)
	num_cores := uint32(0)
	mem_size := uint64(0)

	// Expose NUMA topology consistent with the xir Procs allocation

	// It is not strictly necessary to do this, but the underlying
	// materialization is fixed, and so exposing the topology to the VM should
	// lead to better data placement decisions by the guest OS and comes with
	// no obvious downside

	for socket_id, sock := range topo.SocketMap {
		cmd_list = append(cmd_list, "-numa", fmt.Sprintf("node,nodeid=%d,memdev=m%d", socket_id, socket_id))
		for core := uint32(0); core < sock.NumCores; core++ {
			cmd_list = append(cmd_list, "-numa", fmt.Sprintf("cpu,node-id=%d,socket-id=%d", socket_id, socket_id))
		}
		num_cores += sock.NumCores

		cmd_list = append(cmd_list, "-object", fmt.Sprintf("memory-backend-ram,size=%s,id=m%d",
			strconv.FormatUint(sock.Memory, 10), socket_id))
		mem_size += sock.Memory
	}

	cmd_list = append(cmd_list, "-smp", fmt.Sprintf("%d,sockets=%d,maxcpus=%d", num_cores, num_sockets, num_cores))
	cmd_list = append(cmd_list, "-m", strconv.FormatUint(mem_size/(1<<20), 10))

	return cmd_list, nil
}
*/

func buildQemuNUMATopology(config *VMConfig) ([]string, error) {
	var cmd_list []string

	topo := config.SocketTopo
	num_cores := uint32(0)
	mem_size := uint64(0)

	// Count the number of CPUS and memory bytes allocated by iterating over
	// the socket map

	for _, sock := range topo.SocketMap {
		num_cores += sock.NumCores
		mem_size += sock.Memory
	}

	cmd_list = append(cmd_list, "-smp", fmt.Sprintf("%d,sockets=1,maxcpus=%d", num_cores, num_cores))
	cmd_list = append(cmd_list, "-m", strconv.FormatUint(mem_size/(1<<20), 10))

	return cmd_list, nil
}

func buildKernelCmdLine(fqvm string, config *VMConfig) []string {

	inframac := ""

	// inframac is the MAC on the first port of the first NIC on the PCI bus
	nics := config.PCITopo.Nics
	if nics != nil {
		if nic, ok := nics.NicMap[0]; ok {
			if port, ok := nic.Map[0]; ok {
				inframac = port.Mac
			}
		}
	}

	cmdline := []string{
		"console=tty0",
		"console=ttyS0,115200n8",
		"root=PARTUUID=a0000000-0000-0000-0000-00000000000a",
		"rootfstype=ext4",
		"rw",
		"biosdevname=0",
		"net.ifnames=0",
	}

	if inframac == "" {
		log.Warnf("no inframac found")
	} else {
		cmdline = append(cmdline, fmt.Sprintf("inframac=%s", inframac))
	}

	return cmdline

}

func buildQemuCmdLine(fqvm string, config *VMConfig) ([]string, error) {
	var qemu_cmd []string

	// Build NUMA topology
	numa_topology_cmd, err := buildQemuNUMATopology(config)
	if err != nil {
		return nil, err
	}

	// Build PCIe topology (this cannot be hotplugged, but the actual devices on it can be)
	pcie_topology_cmd, err := buildQemuPCIeTopology(config)
	if err != nil {
		return nil, err
	}

	pid_file := getQemuPidFile(fqvm)
	qmp_sock := getQmpSockFile(fqvm)
	vnc_sock := getVncSockFile(fqvm)
	ser_sock := getSerialSockFile(fqvm)

	// Basic setup
	qemu_cmd = append(qemu_cmd, "-S", "-pidfile", pid_file, "-no-shutdown")
	qemu_cmd = append(qemu_cmd, "-qmp", fmt.Sprintf("unix:%s,server,nowait", qmp_sock))
	qemu_cmd = append(qemu_cmd, "-serial", fmt.Sprintf("unix:%s,server,nowait", ser_sock))
	qemu_cmd = append(qemu_cmd, "-vnc", fmt.Sprintf("unix:%s", vnc_sock))
	qemu_cmd = append(qemu_cmd, "-enable-kvm", "-cpu", "host", "-machine", "q35")
	qemu_cmd = append(qemu_cmd, "-name", fmt.Sprintf("%s", fqvm))
	qemu_cmd = append(qemu_cmd, "-nic", "none")

	// Boot from the EFI variant if we're not bios
	if !config.IsBios {
		qemu_cmd = append(qemu_cmd, "-bios", "/usr/share/edk2/ovmf/OVMF_CODE.fd")
	}

	qemu_cmd = append(qemu_cmd, "-kernel", getKernelFile(fqvm))
	qemu_cmd = append(qemu_cmd, "-initrd", getInitrdFile(fqvm))
	qemu_cmd = append(qemu_cmd, "-append", strings.Join(buildKernelCmdLine(fqvm, config), " "))

	qemu_cmd = append(qemu_cmd, numa_topology_cmd...)
	qemu_cmd = append(qemu_cmd, pcie_topology_cmd...)

	return qemu_cmd, nil
}

func fetchOSImage(fqvm string, config *VMConfig) (bool, error) {
	return fetchAndCacheOS(fqvm, config.OSImage)
}

func releaseOSImage(fqvm string, config *VMConfig) {
	releaseOS(fqvm, config.OSImage)
}

// Currently, this only maps VCPUs to the correct host socket. It does nothing
// with memory. Memory pinning is not as easy via regular util-linux tools.
// Probably the right mechanism to enforce memory limits is to use cgroups, but
// something simpler that uses set_mempolicy (2) could also be appropriate for
// most cases
func mapVMToHostConfig(fqvm string, config *VMConfig) error {
	pid, err := getVMPid(fqvm)
	if err != nil {
		return err
	}

	cpus, err := qmpQueryCpuInfo(fqvm)
	if err != nil {
		return err
	}

	// map thread IDs to physical socket index
	var m = make(map[int]int)
	for _, c := range cpus {
		threadId := c.ThreadId
		vsocket := c.Props.SocketId
		hsocket := config.SocketTopo.HostMap[uint32(vsocket)]
		m[threadId] = int(hsocket)
	}

	return mapVMToHost(fqvm, pid, m)
}

func startAndConfigVm(fqvm string, qemu_cmd []string, config *VMConfig) error {
	err := startVM(fqvm, qemu_cmd)
	if err != nil {
		return err
	}

	// There is not enough intelligence on the realization side to understand
	// socket level resource state on hypervisor nodes. So commenting this out
	// to avoid accidently pinning VMs to an unnecessarily small set of resources
	/*
		err = mapVMToHostConfig(fqvm, config)
		if err != nil {
			return err
		}
	*/

	err = configVMQmp(fqvm, config)
	if err != nil {
		killVM(fqvm)
		return err
	}

	err = qmpStartVM(fqvm)
	if err != nil {
		killVM(fqvm)
		return err
	}

	return nil
}

func checkVMStatus(fqvm string) (bool, error) {
	status, err := qmpCheckVMStatus(fqvm)
	if err != nil {
		return false, err
	}

	if status.Running {
		switch status.Status {
		case "running":
			log.Debugf("found VM '%s' in state: %s", fqvm, status.Status)
			return true, nil
		default:
			log.Debugf("found VM '%s' in state: %s", fqvm, status.Status)
		}
	} else {
		log.Debugf("found non-runnable VM '%s'", fqvm)
	}

	return false, nil
}

func createVM(fqvm string, vm *state.Vm) (*VMConfig, error) {
	l := log.WithFields(log.Fields{
		"fqvm": fqvm,
	})
	l.Debug("handling createVM request")

	spec := vm.Vm.VmAlloc
	err := sanityCheckSpec(spec)
	if err != nil {
		return nil, err
	}

	err = setupVMHost(fqvm)
	if err != nil {
		return nil, err
	}

	// generate a VMConfig based on the provided xir spec
	config, err := xirToVMConfig(fqvm, spec)
	if err != nil {
		return nil, fmt.Errorf("failed to translate xir spec to mariner VM config: %v", err)
	}

	return config, nil
}

func rebootVMWarm(fqvm string) error {
	l := log.WithFields(log.Fields{
		"fqvm": fqvm,
	})
	l.Debug("handling warm reboot request")

	running, err := checkVMStatus(fqvm)
	if err != nil {
		return fmt.Errorf("failed to get VM status: %+v", err)
	}

	if running {
		err = qmpPowerdownVM(fqvm, SOFT_REBOOT_TIMEOUT_SEC)
		if err != nil {
			return err
		}
	}

	err = qmpCycleVM(fqvm)
	if err != nil {
		return err
	}

	return qmpStartVM(fqvm)
}

func rebootVMCold(fqvm string) error {
	l := log.WithFields(log.Fields{
		"fqvm": fqvm,
	})
	l.Debug("handling cold reboot request")

	running, err := checkVMStatus(fqvm)
	if err != nil {
		return fmt.Errorf("failed to get VM status: %+v", err)
	}

	err = qmpCycleVM(fqvm)
	if err != nil {
		return err
	}

	if running {
		return nil
	}

	return qmpStartVM(fqvm)
}

func marinerVMStates() (map[string]bool, error) {
	states := make(map[string]bool)

	vms, err := getAllVMs()
	if err != nil {
		return states, err
	}

	for _, fqvm := range vms {
		running, err := checkVMStatus(fqvm)
		if err != nil || !running {
			states[fqvm] = false
		} else {
			states[fqvm] = true
		}
	}

	return states, nil
}

func marinerCreateVM(fqvm string, vm *state.Vm) error {
	l := log.WithFields(log.Fields{
		"fqvm": fqvm,
	})
	l.Debug("marinerCreateVM")

	// Fail if the VM exists
	_, err := checkVMStatus(fqvm)
	if err == nil {
		return fmt.Errorf("VM exists")
	}

	// Clear any old state that may have been associated with this fqvm previously
	reapVM(fqvm)

	// Generate VM config
	config, err := createVM(fqvm, vm)
	if err != nil {
		return err
	}

	// reap if anything beloew fails
	defer func() {
		if err != nil {
			reapVMConfig(fqvm, config)
		}
	}()

	config.IsBios, err = fetchOSImage(fqvm, config)
	if err != nil {
		return err
	}

	qemu_cmd, err := buildQemuCmdLine(fqvm, config)
	if err != nil {
		return err
	}

	err = startAndConfigVm(fqvm, qemu_cmd, config)
	if err != nil {
		return err
	}

	err = saveVMConfig(fqvm, config)
	if err != nil {
		killVM(fqvm)
		return err
	}

	l.Info("started VM")
	return nil
}

func marinerReloadVM(fqvm string, reimage bool) error {
	l := log.WithFields(log.Fields{
		"fqvm":    fqvm,
		"reimage": reimage,
	})
	l.Debug("marinerReloadVM")

	config, err := restoreVMConfig(fqvm)
	if err != nil {
		return err
	}

	// clean up NICs is the only step for reloading a present VM
	running, err := checkVMStatus(fqvm)
	if err == nil {
		if running {
			err = killVM(fqvm)
			if err != nil {
				return err
			}
		}

		err = reapVMNics(config.PCITopo.Nics)
		if err != nil {
			return err
		}
	}

	if reimage {
		err = wipeRootfs(fqvm, config.OSImage)
		if err != nil {
			return err
		}
	}

	qemu_cmd, err := buildQemuCmdLine(fqvm, config)
	if err != nil {
		return err
	}

	err = startAndConfigVm(fqvm, qemu_cmd, config)
	if err != nil {
		return err
	}

	err = saveVMConfig(fqvm, config)
	if err != nil {
		killVM(fqvm)
		return err
	}

	l.Info("reloaded VM")
	return nil
}

func marinerKillVM(fqvm string) error {
	l := log.WithFields(log.Fields{
		"fqvm": fqvm,
	})
	l.Debug("marinerKillVM")

	// always reap no matter the state we find this VM in
	killVM(fqvm)
	reapVM(fqvm)

	l.Info("killed VM")
	return nil
}

func marinerRebootVM(fqvm string, mode portal.RebootMaterializationMode) error {
	l := log.WithFields(log.Fields{
		"fqvm": fqvm,
		"mode": mode,
	})
	l.Debug("marinerRebootVM")

	var err error
	switch mode {
	case portal.RebootMaterializationMode_Reboot:
		err = rebootVMWarm(fqvm)
	case portal.RebootMaterializationMode_Cycle:
		err = rebootVMCold(fqvm)
	default:
		return fmt.Errorf("unknown reboot mode: %+v", mode)
	}

	if err != nil {
		return err
	}

	l.Info("rebooted VM")
	return nil
}

func marinerReimageVM(fqvm string) error {
	l := log.WithFields(log.Fields{
		"fqvm": fqvm,
	})
	l.Debug("marinerReimageVM")

	err := marinerReloadVM(fqvm, true)
	if err != nil {
		return err
	}
	l.Info("VM reimage complete")
	return nil
}
